"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var strings_1 = require("../../strings");
var nameValidator_1 = require("../../nameValidator");
var createNewNotebookCommonProperties_1 = require("./createNewNotebookCommonProperties");
var createNewNotebookRowTemplate_1 = require("./createNewNotebookRowTemplate");
var errorIconWithPopover_1 = require("../errorIconWithPopover");
var CreateNewNotebookInputRenderStrategy = /** @class */ (function (_super) {
    __extends(CreateNewNotebookInputRenderStrategy, _super);
    function CreateNewNotebookInputRenderStrategy(notebookNameInputValue, props, onEnterBinded, onChangeBinded, inputRefBinded, setInputToNotStarted) {
        var _this = _super.call(this) || this;
        _this.notebookNameInputValue = notebookNameInputValue;
        _this.props = props;
        _this.onEnterBinded = onEnterBinded;
        _this.onChangeBinded = onChangeBinded;
        _this.inputRefBinded = inputRefBinded;
        _this.setInputToNotStarted = setInputToNotStarted;
        _this.onClickBinded = _this.onClick.bind(_this);
        return _this;
    }
    CreateNewNotebookInputRenderStrategy.prototype.element = function () {
        return (React.createElement(createNewNotebookRowTemplate_1.CreateNewNotebookRowTemplate, null,
            React.createElement("div", { className: 'picker-label' },
                React.createElement("div", { className: 'picker-input-and-error' },
                    React.createElement("input", { className: 'create-input', ref: this.inputRefBinded, type: 'text', name: 'notebookName', placeholder: strings_1.Strings.get('Input.CreateNotebookPlaceholder'), autoComplete: 'off', value: this.notebookNameInputValue, onKeyPress: this.onKeyPress.bind(this), onChange: this.onInputChange.bind(this) }),
                    React.createElement(errorIconWithPopover_1.ErrorIconWithPopover, { errorMessage: this.errorIfExists() }))),
            React.createElement("i", { className: 'picker-input-x ms-Icon ms-Icon--Clear', onClick: this.setInputToNotStarted })));
    };
    CreateNewNotebookInputRenderStrategy.prototype.errorIfExists = function () {
        return nameValidator_1.NameValidator.validateNotebookName(this.notebookNameInputValue);
    };
    CreateNewNotebookInputRenderStrategy.prototype.onKeyPress = function (event) {
        if (event.key === 'Enter') {
            this.onEnterBinded(event);
        }
    };
    CreateNewNotebookInputRenderStrategy.prototype.onInputChange = function (event) {
        var notebookName = event.target.value;
        var onNotebookInputValueChanged = this.props.callbacks.onNotebookInputValueChanged;
        if (!!onNotebookInputValueChanged) {
            onNotebookInputValueChanged(notebookName);
        }
        var onNotebookInputSelected = this.props.callbacks.onNotebookInputSelected;
        if (!!onNotebookInputSelected) {
            onNotebookInputSelected();
        }
        this.onChangeBinded(event);
    };
    CreateNewNotebookInputRenderStrategy.prototype.onClick = function () {
        var onNotebookInputSelected = this.props.callbacks.onNotebookInputSelected;
        if (!!onNotebookInputSelected) {
            onNotebookInputSelected();
        }
    };
    return CreateNewNotebookInputRenderStrategy;
}(createNewNotebookCommonProperties_1.CreateNewNotebookCommonProperties));
exports.CreateNewNotebookInputRenderStrategy = CreateNewNotebookInputRenderStrategy;
//# sourceMappingURL=createNewNotebookInputRenderStrategy.js.map