"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var createNewNotebookNotStartedRenderStrategy_1 = require("./createNewNotebookNotStartedRenderStrategy");
var createNewNotebookInputRenderStrategy_1 = require("./createNewNotebookInputRenderStrategy");
var createNewNotebookInProgressRenderStrategy_1 = require("./createNewNotebookInProgressRenderStrategy");
var createNewNotebookErrorRenderStrategy_1 = require("./createNewNotebookErrorRenderStrategy");
var createEntityNode_1 = require("../treeView/createEntityNode");
/**
 * Presentation component that extends the 'Create' UX with notebook-specific
 * UI.
 */
var CreateNewNotebookNode = /** @class */ (function (_super) {
    __extends(CreateNewNotebookNode, _super);
    function CreateNewNotebookNode(props) {
        var _this = _super.call(this, props) || this;
        _this.notStartedRenderStrategy = _this.notStartedRenderStrategy.bind(_this);
        _this.inputRenderStrategy = _this.inputRenderStrategy.bind(_this);
        _this.createErrorRenderStrategy = _this.createErrorRenderStrategy.bind(_this);
        _this.inProgressRenderStrategy = _this.inProgressRenderStrategy.bind(_this);
        _this.createNotebook = _this.createNotebook.bind(_this);
        return _this;
    }
    CreateNewNotebookNode.prototype.notStartedRenderStrategy = function (onClick) {
        return new createNewNotebookNotStartedRenderStrategy_1.CreateNewNotebookNotStartedRenderStrategy(onClick, this.props.callbacks);
    };
    CreateNewNotebookNode.prototype.inputRenderStrategy = function (inputValue, onEnter, onInputChange, setInputRefAndFocus, setInputToNotStarted) {
        return new createNewNotebookInputRenderStrategy_1.CreateNewNotebookInputRenderStrategy(inputValue, this.props, onEnter, onInputChange, setInputRefAndFocus, setInputToNotStarted);
    };
    CreateNewNotebookNode.prototype.createErrorRenderStrategy = function (errorMessage, inputValue, onInputChange, setInputToNotStarted) {
        return new createNewNotebookErrorRenderStrategy_1.CreateNewNotebookErrorRenderStrategy(errorMessage, inputValue, onInputChange, setInputToNotStarted);
    };
    CreateNewNotebookNode.prototype.inProgressRenderStrategy = function (inputValue) {
        return new createNewNotebookInProgressRenderStrategy_1.CreateNewNotebookInProgressRenderStrategy(inputValue);
    };
    CreateNewNotebookNode.prototype.createNotebook = function (name) {
        var _this = this;
        return this.props.oneNoteDataProvider.createNotebook(name).then(function (notebook) {
            return _this.props.callbacks.onNotebookCreated(notebook);
        });
    };
    CreateNewNotebookNode.prototype.render = function () {
        return (React.createElement(createEntityNode_1.CreateEntityNode, __assign({}, this.props, { notStartedRenderStrategy: this.notStartedRenderStrategy, inputRenderStrategy: this.inputRenderStrategy, createErrorRenderStrategy: this.createErrorRenderStrategy, inProgressRenderStrategy: this.inProgressRenderStrategy, createEntity: this.props.callbacks.onNotebookCreated ? this.createNotebook : undefined })));
    };
    return CreateNewNotebookNode;
}(React.Component));
exports.CreateNewNotebookNode = CreateNewNotebookNode;
//# sourceMappingURL=createNewNotebookNode.js.map