"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var strings_1 = require("../../strings");
var nameValidator_1 = require("../../nameValidator");
var createNewSectionCommonProperties_1 = require("./createNewSectionCommonProperties");
var createNewSectionRowTemplate_1 = require("./createNewSectionRowTemplate");
var errorIconWithPopover_1 = require("../errorIconWithPopover");
var CreateNewSectionInputRenderStrategy = /** @class */ (function (_super) {
    __extends(CreateNewSectionInputRenderStrategy, _super);
    function CreateNewSectionInputRenderStrategy(parentId, notebookNameInputValue, props, onEnterBinded, onChangeBinded, inputRefBinded, setInputToNotStarted) {
        var _this = _super.call(this, parentId) || this;
        _this.notebookNameInputValue = notebookNameInputValue;
        _this.props = props;
        _this.onEnterBinded = onEnterBinded;
        _this.onChangeBinded = onChangeBinded;
        _this.inputRefBinded = inputRefBinded;
        _this.setInputToNotStarted = setInputToNotStarted;
        _this.onClickBinded = _this.onClick.bind(_this);
        return _this;
    }
    CreateNewSectionInputRenderStrategy.prototype.element = function () {
        return (React.createElement(createNewSectionRowTemplate_1.CreateNewSectionRowTemplate, null,
            React.createElement("div", { className: 'picker-label' },
                React.createElement("div", { className: 'picker-input-and-error' },
                    React.createElement("input", { className: 'create-input', ref: this.inputRefBinded, type: 'text', placeholder: strings_1.Strings.get('Input.CreateSectionPlaceholder'), autoComplete: 'off', value: this.notebookNameInputValue, onKeyPress: this.onKeyPress.bind(this), onChange: this.onInputChange.bind(this) }),
                    React.createElement(errorIconWithPopover_1.ErrorIconWithPopover, { errorMessage: this.errorIfExists() }))),
            React.createElement("i", { className: 'picker-input-x ms-Icon ms-Icon--Clear', onClick: this.setInputToNotStarted })));
    };
    CreateNewSectionInputRenderStrategy.prototype.errorIfExists = function () {
        return nameValidator_1.NameValidator.validateSectionName(this.notebookNameInputValue);
    };
    CreateNewSectionInputRenderStrategy.prototype.onKeyPress = function (event) {
        if (event.key === 'Enter') {
            this.onEnterBinded(event);
        }
    };
    CreateNewSectionInputRenderStrategy.prototype.onInputChange = function (event) {
        var sectionName = event.target.value;
        var onSectionInputValueChanged = this.props.callbacks.onSectionInputValueChanged;
        if (!!onSectionInputValueChanged) {
            onSectionInputValueChanged(sectionName);
        }
        var onSectionInputSelected = this.props.callbacks.onSectionInputSelected;
        if (!!onSectionInputSelected) {
            onSectionInputSelected(this.props.parent, this.props.parentIsNotebook, sectionName);
        }
        this.onChangeBinded(event);
    };
    CreateNewSectionInputRenderStrategy.prototype.onClick = function () {
        var onSectionInputSelected = this.props.callbacks.onSectionInputSelected;
        if (!!onSectionInputSelected) {
            onSectionInputSelected(this.props.parent, this.props.parentIsNotebook, this.notebookNameInputValue);
        }
    };
    return CreateNewSectionInputRenderStrategy;
}(createNewSectionCommonProperties_1.CreateNewSectionCommonProperties));
exports.CreateNewSectionInputRenderStrategy = CreateNewSectionInputRenderStrategy;
//# sourceMappingURL=createNewSectionInputRenderStrategy.js.map