/// <reference types="react" />
import * as React from 'react';
import { Notebook } from '../../oneNoteDataStructures/notebook';
import { SectionGroup } from '../../oneNoteDataStructures/sectionGroup';
import { InnerGlobals } from '../../props/globalProps';
export interface CreateNewSectionNodeProps extends InnerGlobals {
    level: number;
    tabbable: boolean;
    parent: Notebook | SectionGroup;
    parentIsNotebook: boolean;
}
/**
 * Presentation component that extends the 'Create' UX with section-specific
 * UI.
 */
export declare class CreateNewSectionNode extends React.Component<CreateNewSectionNodeProps, {}> {
    constructor(props: CreateNewSectionNodeProps);
    private notStartedRenderStrategy(onClick);
    private inputRenderStrategy(inputValue, onEnter, onInputChange, setInputRefAndFocus, setInputToNotStarted);
    private createErrorRenderStrategy(errorMessage, inputValue, onInputChange, setInputToNotStarted);
    private inProgressRenderStrategy(inputValue);
    private createSection(name);
    private getParentId();
    render(): JSX.Element;
}
