"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var createNewSectionNotStartedRenderStrategy_1 = require("./createNewSectionNotStartedRenderStrategy");
var createNewSectionInputRenderStrategy_1 = require("./createNewSectionInputRenderStrategy");
var createNewSectionInProgressRenderStrategy_1 = require("./createNewSectionInProgressRenderStrategy");
var createNewSectionErrorRenderStrategy_1 = require("./createNewSectionErrorRenderStrategy");
var createEntityNode_1 = require("../treeView/createEntityNode");
/**
 * Presentation component that extends the 'Create' UX with section-specific
 * UI.
 */
var CreateNewSectionNode = /** @class */ (function (_super) {
    __extends(CreateNewSectionNode, _super);
    function CreateNewSectionNode(props) {
        var _this = _super.call(this, props) || this;
        _this.notStartedRenderStrategy = _this.notStartedRenderStrategy.bind(_this);
        _this.inputRenderStrategy = _this.inputRenderStrategy.bind(_this);
        _this.createErrorRenderStrategy = _this.createErrorRenderStrategy.bind(_this);
        _this.inProgressRenderStrategy = _this.inProgressRenderStrategy.bind(_this);
        _this.createSection = _this.createSection.bind(_this);
        return _this;
    }
    CreateNewSectionNode.prototype.notStartedRenderStrategy = function (onClick) {
        return new createNewSectionNotStartedRenderStrategy_1.CreateNewSectionNotStartedRenderStrategy(this.getParentId(), onClick, this.props);
    };
    CreateNewSectionNode.prototype.inputRenderStrategy = function (inputValue, onEnter, onInputChange, setInputRefAndFocus, setInputToNotStarted) {
        return new createNewSectionInputRenderStrategy_1.CreateNewSectionInputRenderStrategy(this.getParentId(), inputValue, this.props, onEnter, onInputChange, setInputRefAndFocus, setInputToNotStarted);
    };
    CreateNewSectionNode.prototype.createErrorRenderStrategy = function (errorMessage, inputValue, onInputChange, setInputToNotStarted) {
        return new createNewSectionErrorRenderStrategy_1.CreateNewSectionErrorRenderStrategy(this.getParentId(), errorMessage, inputValue, onInputChange, setInputToNotStarted);
    };
    CreateNewSectionNode.prototype.inProgressRenderStrategy = function (inputValue) {
        return new createNewSectionInProgressRenderStrategy_1.CreateNewSectionInProgressRenderStrategy(this.getParentId(), inputValue);
    };
    CreateNewSectionNode.prototype.createSection = function (name) {
        var _this = this;
        var createSectionPromise = this.props.parentIsNotebook ?
            this.props.oneNoteDataProvider.createSectionUnderNotebook(this.props.parent, name) :
            this.props.oneNoteDataProvider.createSectionUnderSectionGroup(this.props.parent, name);
        return createSectionPromise.then(function (section) {
            return _this.props.callbacks.onSectionCreated(section);
        });
    };
    CreateNewSectionNode.prototype.getParentId = function () {
        var parentSharedNotebook = this.props.parent;
        return parentSharedNotebook.apiProperties ? parentSharedNotebook.apiProperties.id : this.props.parent.id;
    };
    CreateNewSectionNode.prototype.render = function () {
        return (React.createElement(createEntityNode_1.CreateEntityNode, __assign({}, this.props, { notStartedRenderStrategy: this.notStartedRenderStrategy, inputRenderStrategy: this.inputRenderStrategy, createErrorRenderStrategy: this.createErrorRenderStrategy, inProgressRenderStrategy: this.inProgressRenderStrategy, createEntity: this.props.callbacks.onSectionCreated ? this.createSection : undefined })));
    };
    return CreateNewSectionNode;
}(React.Component));
exports.CreateNewSectionNode = CreateNewSectionNode;
//# sourceMappingURL=createNewSectionNode.js.map