"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_popper_1 = require("react-popper");
var errorInfoIcon_svg_1 = require("./icons/errorInfoIcon.svg");
var ErrorIconWithPopover = /** @class */ (function (_super) {
    __extends(ErrorIconWithPopover, _super);
    function ErrorIconWithPopover(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            popoverIsOpen: false
        };
        // Used to handle if user clicks outside error icon, the popover should close
        _this.setWrapperRef = _this.setWrapperRef.bind(_this);
        _this.handleClickOutside = _this.handleClickOutside.bind(_this);
        // Used to handle if the user scrolls anywhere on the page, the popover should close
        _this.scrollHandler = _this.scrollHandler.bind(_this);
        // Used to handle if the user hits space on the error icon, the popover should toggle visibility
        _this.keyUpHandler = _this.keyUpHandler.bind(_this);
        // Used to handle if the user clicks the error icon, the popover should toggle visibility
        _this.clickHandler = _this.clickHandler.bind(_this);
        return _this;
    }
    ErrorIconWithPopover.prototype.componentDidMount = function () {
        document.addEventListener('mousedown', this.handleClickOutside);
        window.addEventListener('scroll', this.scrollHandler, true);
    };
    ErrorIconWithPopover.prototype.componentWillUnmount = function () {
        document.removeEventListener('mousedown', this.handleClickOutside);
        window.removeEventListener('scroll', this.scrollHandler, true);
    };
    ErrorIconWithPopover.prototype.handleClickOutside = function (event) {
        if (this.wrapperRef && !this.wrapperRef.contains(event.target) && this.state.popoverIsOpen) {
            this.setState({
                popoverIsOpen: false
            });
        }
    };
    ErrorIconWithPopover.prototype.setWrapperRef = function (node) {
        this.wrapperRef = node;
    };
    ErrorIconWithPopover.prototype.scrollHandler = function () {
        this.setState({
            popoverIsOpen: false
        });
    };
    ErrorIconWithPopover.prototype.keyUpHandler = function (event) {
        // Space
        if (event.keyCode === 32) {
            this.clickHandler();
        }
    };
    ErrorIconWithPopover.prototype.clickHandler = function () {
        this.setState({
            popoverIsOpen: !this.state.popoverIsOpen
        });
    };
    ErrorIconWithPopover.prototype.render = function () {
        return (React.createElement("div", { ref: this.setWrapperRef, className: 'error-info-icon' },
            React.createElement(react_popper_1.Manager, null,
                React.createElement(react_popper_1.Target, null,
                    React.createElement("div", { tabIndex: 0, style: this.props.errorMessage ? {} : { display: 'none' }, onClick: this.clickHandler, onKeyUp: this.keyUpHandler },
                        React.createElement(errorInfoIcon_svg_1.ErrorInfoIconSvg, null))),
                React.createElement(react_popper_1.Popper, { placement: 'bottom', modifiers: {
                        hide: {
                            enabled: false
                        },
                        preventOverflow: {
                            enabled: true,
                        },
                        arrow: {
                            enabled: true
                        }
                    }, style: this.shouldShowPopover() ? {} : { visibility: 'hidden' }, className: 'error-info-popover popper', eventsEnabled: true },
                    React.createElement("div", { className: 'error-info-popover-content' }, this.props.errorMessage),
                    React.createElement(react_popper_1.Arrow, { className: 'popper__arrow' })))));
    };
    ErrorIconWithPopover.prototype.shouldShowPopover = function () {
        return this.state.popoverIsOpen;
    };
    return ErrorIconWithPopover;
}(React.Component));
exports.ErrorIconWithPopover = ErrorIconWithPopover;
//# sourceMappingURL=errorIconWithPopover.js.map