"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var strings_1 = require("../strings");
var oneNoteItemUtils_1 = require("../oneNoteDataStructures/oneNoteItemUtils");
var PageRenderStrategy = /** @class */ (function () {
    function PageRenderStrategy(page, globals) {
        this.page = page;
        this.globals = globals;
        this.onClickBinded = this.onClick.bind(this);
    }
    PageRenderStrategy.prototype.element = function () {
        // TODO image is a placeholder as we don't support pages yet
        return (React.createElement("div", { className: this.isSelected() ? 'picker-selectedItem' : '', title: this.page.name },
            React.createElement("div", { className: 'picker-icon' },
                React.createElement("img", { src: require('../images/section_icon.png'), alt: strings_1.Strings.get('Accessibility.PageIcon') })),
            React.createElement("div", null,
                React.createElement("label", { className: 'ms-fontSize-sPlus' }, this.page.name))));
    };
    PageRenderStrategy.prototype.getName = function () {
        return this.page.name;
    };
    PageRenderStrategy.prototype.getId = function () {
        return this.page.id;
    };
    PageRenderStrategy.prototype.isSelected = function () {
        return this.globals.selectedId === this.page.id;
    };
    PageRenderStrategy.prototype.isAriaSelected = function () {
        return this.globals.ariaSelectedId ? this.globals.ariaSelectedId === this.getId() : false;
    };
    PageRenderStrategy.prototype.onClick = function () {
        var onPageSelected = this.globals.callbacks.onPageSelected;
        if (!!onPageSelected) {
            onPageSelected(this.page, oneNoteItemUtils_1.OneNoteItemUtils.getAncestry(this.page));
        }
    };
    return PageRenderStrategy;
}());
exports.PageRenderStrategy = PageRenderStrategy;
//# sourceMappingURL=pageRenderStrategy.js.map