"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var leafNode_1 = require("../treeView/leafNode");
var recentSectionsCommonProperties_1 = require("./recentSectionsCommonProperties");
var constants_1 = require("../../constants");
var recentSectionRenderStrategy_1 = require("./recentSectionRenderStrategy");
var RecentSectionHeaderRenderStrategy = /** @class */ (function (_super) {
    __extends(RecentSectionHeaderRenderStrategy, _super);
    function RecentSectionHeaderRenderStrategy(sections, expanded, props, onRecentSectionsClick) {
        var _this = _super.call(this) || this;
        _this.sections = sections;
        _this.expanded = expanded;
        _this.props = props;
        _this.onRecentSectionsClick = onRecentSectionsClick;
        _this.onClickBinded = function () { };
        _this.onExpandBinded = function () { };
        _this.onCollapseBinded = function () { };
        _this.expanded = expanded;
        _this.onExpandBinded = function () { _this.onRecentSectionsClick(true); };
        _this.onCollapseBinded = function () { _this.onRecentSectionsClick(false); };
        return _this;
    }
    /*
    We decoupled the render strategy from the component in this case and thus do not need to return an element here.
    The Recent Sections component needs to be able to maintain its own state and pass an onExpand callback as props to the
    Expandable Node component. This allows the Expandable Node component to inform the Recent Sections component of a
    click event through a callback so that the Recent Sections component can update its state properly. We will revisit
    this quirk when we refactor the next time.
    */
    RecentSectionHeaderRenderStrategy.prototype.element = function () {
        return React.createElement("span", null);
    };
    RecentSectionHeaderRenderStrategy.prototype.getChildren = function (childrenLevel) {
        var _this = this;
        var recentSectionRenderStrategies = this.sections ?
            this.sections.map(function (section) { return new recentSectionRenderStrategy_1.RecentSectionRenderStrategy(section, _this.props); }) : [];
        var sections = recentSectionRenderStrategies.map(function (renderStrategy, i) {
            return React.createElement(leafNode_1.LeafNode, { globals: _this.props, node: renderStrategy, treeViewId: constants_1.Constants.TreeView.id, key: renderStrategy.getId() + 'recent-section', id: renderStrategy.getId(), ariaSelected: _this.props.ariaSelectedId ? renderStrategy.isAriaSelected() : false, selected: renderStrategy.isSelected(), level: childrenLevel, setsize: _this.sections.length, posinset: i + 1 });
        });
        return sections.slice();
    };
    RecentSectionHeaderRenderStrategy.prototype.isExpanded = function () {
        return this.expanded;
    };
    RecentSectionHeaderRenderStrategy.prototype.isSelected = function () {
        return this.props.selectedId === this.getId();
    };
    RecentSectionHeaderRenderStrategy.prototype.isAriaSelected = function () {
        return this.props.ariaSelectedId ? this.props.ariaSelectedId === this.getId() : false;
    };
    RecentSectionHeaderRenderStrategy.prototype.getId = function () {
        return constants_1.Constants.TreeView.recentSectionsId;
    };
    return RecentSectionHeaderRenderStrategy;
}(recentSectionsCommonProperties_1.RecentSectionsCommonProperties));
exports.RecentSectionHeaderRenderStrategy = RecentSectionHeaderRenderStrategy;
//# sourceMappingURL=recentSectionHeaderRenderStrategy.js.map