/// <reference types="react" />
import * as React from 'react';
import { NodeRenderStrategy } from './nodeRenderStrategy';
import { InnerGlobals } from '../../props/globalProps';
export interface CreateEntityNodeProps extends InnerGlobals {
    tabbable: boolean;
    level: number;
    notStartedRenderStrategy: (onClick: () => void) => NodeRenderStrategy;
    inputRenderStrategy: (inputValue: string, onEnter: () => void, onInputChange: (evt: React.ChangeEvent<HTMLInputElement>) => void, setInputRefAndFocus: (node: HTMLInputElement) => void, setInputToNotStarted: () => void) => NodeRenderStrategy;
    createErrorRenderStrategy: (errorMessage: string, inputValue: string, onInputChange: (evt: React.ChangeEvent<HTMLInputElement>) => void, setInputToNotStarted: () => void) => NodeRenderStrategy;
    inProgressRenderStrategy: (inputValue: string) => NodeRenderStrategy;
    createEntity?: (name: string) => Promise<void>;
}
export interface CreateEntityNodeState {
    status: 'NotStarted' | 'Input' | 'CreateError' | 'InProgress';
    nameInputValue: string;
    lastError?: any;
}
/**
 * Functional component for creating a particular entity e.g., notebook. UI logic
 * should be passed in as props.
 */
export declare class CreateEntityNode extends React.Component<CreateEntityNodeProps, CreateEntityNodeState> {
    private wrapperRef;
    private inputRef;
    private componentIsMounted;
    constructor(props: CreateEntityNodeProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    private handleClickOutside(event);
    private handleEnterInput();
    private resetAndFocus();
    private defaultState();
    render(): JSX.Element;
    private setWrapperRef(node);
    private onClick();
    private setInputToNotStarted();
    private onInputChange(event);
    private setInputRefAndFocus(node);
}
