"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var treeViewNavigationUtils_1 = require("./treeViewNavigationUtils");
var LeafNode = /** @class */ (function (_super) {
    __extends(LeafNode, _super);
    function LeafNode() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LeafNode.prototype.onClick = function () {
        this.props.node.onClickBinded();
        this.props.globals.callbacks.onAccessibleSelection(this.props.id);
    };
    LeafNode.prototype.onKeyDown = function (event) {
        treeViewNavigationUtils_1.TreeViewNavigationUtils.normalizeKeyboardEventBehaviour(event);
        treeViewNavigationUtils_1.TreeViewNavigationUtils.handleMovementKeyboardEvent(this.props.id, this.props.treeViewId, event, this.props.globals.callbacks.onAccessibleSelection);
        switch (event.keyCode) {
            case 32:
                // Space
                this.props.node.onClickBinded();
                break;
            default:
                break;
        }
    };
    LeafNode.prototype.componentDidMount = function () {
        var _a = this.props, focusOnMount = _a.focusOnMount, id = _a.id;
        if (focusOnMount) {
            var self_1 = document.querySelector("[data-id='" + id + "']");
            self_1.focus();
        }
    };
    LeafNode.prototype.level = function () {
        return this.props.level || 1;
    };
    LeafNode.prototype.descendentId = function () {
        return this.props.treeViewId + this.props.id;
    };
    LeafNode.prototype.render = function () {
        return (React.createElement("li", null,
            React.createElement("a", { id: this.descendentId(), className: 'picker-row', onClick: this.onClick.bind(this), onKeyDown: this.onKeyDown.bind(this), "data-treeviewid": this.props.treeViewId, "data-id": this.props.id, tabIndex: this.props.ariaSelected ? 0 : -1, role: 'treeitem', "aria-labelledby": this.descendentId(), "aria-level": this.level(), "aria-selected": this.props.selected, "aria-setsize": this.props.setsize, "aria-posinset": this.props.posinset }, this.props.node.element())));
    };
    return LeafNode;
}(React.Component));
exports.LeafNode = LeafNode;
//# sourceMappingURL=leafNode.js.map