import * as OneNoteApi from 'onenoteapi';
import { Notebook } from './notebook';
import { SectionGroup } from './sectionGroup';
import { Section } from './section';
import { Page } from './page';
/**
 * Provides methods to transform data structures to equivalent data
 * structures used by the OneNotePicker.
 */
export declare class OneNoteApiResponseTransformer {
    private defaultExpanded;
    transformNotebooks(notebookList: OneNoteApi.Notebook[]): Notebook[];
    transformNotebook(notebook: OneNoteApi.Notebook): Notebook;
    transformSectionGroup(sectionGroup: OneNoteApi.SectionGroup, parent: Notebook | SectionGroup): SectionGroup;
    transformSection(section: OneNoteApi.Section, parent: Notebook | SectionGroup): Section;
    transformPages(pageList: OneNoteApi.Page[], parent: Section): Page[];
    transformPage(page: OneNoteApi.Page, parent: Section): Page;
}
