"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
require("./index.css?raw");
var oneNotePickerBase_1 = require("./oneNotePickerBase");
var notebookRenderStrategy_1 = require("./components/notebookRenderStrategy");
var sharedNotebookRenderStrategy_1 = require("./components/sharedNotebookRenderStrategy");
var expandableNode_1 = require("./components/treeView/expandableNode");
var leafNode_1 = require("./components/treeView/leafNode");
var createNewNotebookNode_1 = require("./components/createNewNotebook/createNewNotebookNode");
var recentSectionsNode_1 = require("./components/recentSections/recentSectionsNode");
var recentSectionHeaderRenderStrategy_1 = require("./components/recentSections/recentSectionHeaderRenderStrategy");
var OneNotePicker = /** @class */ (function (_super) {
    __extends(OneNotePicker, _super);
    function OneNotePicker(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            recentSectionsExpanded: true
        };
        return _this;
    }
    OneNotePicker.prototype.rootNodes = function () {
        var _this = this;
        var _a = this.props, notebooks = _a.notebooks, sharedNotebooks = _a.sharedNotebooks, recentSections = _a.recentSections, globals = _a.globals;
        var focusOnMount = globals.focusOnMount, ariaSelectedId = globals.ariaSelectedId;
        var recentSectionsExpanded = this.state.recentSectionsExpanded;
        // Sort both personal and shared notebooks by last modified time (last accessed time for shared notebooks)
        var allNotebooks = notebooks || [];
        if (sharedNotebooks) {
            allNotebooks = allNotebooks.concat(sharedNotebooks);
        }
        allNotebooks.sort(this.sortNotebooksByLastModifiedTime);
        var noPersonalNotebooks = !notebooks || notebooks.length === 0;
        // The key here is guaranteed to be unique as there is only one max 'Create notebook' affordance
        var createNewNotebookExists = this.props.globals.callbacks.onNotebookCreated || this.props.globals.shouldShowCreateEntityInputs;
        var createNewNotebook = createNewNotebookExists ?
            [React.createElement(createNewNotebookNode_1.CreateNewNotebookNode, __assign({ key: 'createnewnotebooknode' }, this.props.globals, { level: 1, tabbable: true, focusOnMount: focusOnMount }))] :
            [];
        var recentSectionRenderStrategy, recentSectionsExists = false;
        if (recentSections && recentSections.length > 0) {
            recentSectionRenderStrategy = new recentSectionHeaderRenderStrategy_1.RecentSectionHeaderRenderStrategy(recentSections, recentSectionsExpanded, globals, this.onRecentSectionsClick.bind(this));
            recentSectionsExists = true;
        }
        var recentSectionNodes = recentSectionRenderStrategy ?
            [React.createElement(recentSectionsNode_1.RecentSectionsNode, { key: recentSectionRenderStrategy.getId(), globals: this.props.globals, level: 1, tabbable: true, focusOnMount: !createNewNotebookExists && focusOnMount, sections: recentSections || [], treeViewId: this.treeViewId(), id: recentSectionRenderStrategy.getId(), ariaSelected: ariaSelectedId ? recentSectionRenderStrategy.isAriaSelected() : true, node: recentSectionRenderStrategy, expanded: recentSectionRenderStrategy.isExpanded(), onRecentSectionsClick: this.onRecentSectionsClick.bind(this) })] : [];
        var allNotebookNodes = allNotebooks.map(function (notebook, i) {
            if (notebook.sourceService) {
                var renderStrategy = new sharedNotebookRenderStrategy_1.SharedNotebookRenderStrategy(notebook, globals);
                return !!_this.props.globals.callbacks.onSectionSelected || !!_this.props.globals.callbacks.onPageSelected ?
                    React.createElement(expandableNode_1.ExpandableNode, { globals: _this.props.globals, expanded: renderStrategy.isExpanded(), node: renderStrategy, treeViewId: _this.treeViewId(), key: renderStrategy.getId(), id: renderStrategy.getId(), tabbable: !createNewNotebookExists && noPersonalNotebooks && i === 0, focusOnMount: !createNewNotebookExists && !recentSectionsExists && focusOnMount && i === 0, ariaSelected: ariaSelectedId ? renderStrategy.isAriaSelected() : !recentSectionsExists && i === 0, selected: renderStrategy.isSelected(), setsize: allNotebooks.length, posinset: i + 1 }) :
                    React.createElement(leafNode_1.LeafNode, { globals: _this.props.globals, node: renderStrategy, treeViewId: _this.treeViewId(), key: renderStrategy.getId(), id: renderStrategy.getId(), tabbable: !createNewNotebookExists && noPersonalNotebooks && i === 0, focusOnMount: !createNewNotebookExists && !recentSectionsExists && focusOnMount && i === 0, ariaSelected: ariaSelectedId ? renderStrategy.isAriaSelected() : !recentSectionsExists && i === 0 });
            }
            else {
                var renderStrategy = new notebookRenderStrategy_1.NotebookRenderStrategy(notebook, globals);
                return !!_this.props.globals.callbacks.onSectionSelected || !!_this.props.globals.callbacks.onPageSelected ?
                    React.createElement(expandableNode_1.ExpandableNode, { globals: _this.props.globals, expanded: renderStrategy.isExpanded(), node: renderStrategy, treeViewId: _this.treeViewId(), key: renderStrategy.getId(), id: renderStrategy.getId(), tabbable: !createNewNotebookExists && !recentSectionsExists && i === 0, focusOnMount: !createNewNotebookExists && !recentSectionsExists && focusOnMount && i === 0, ariaSelected: ariaSelectedId ? renderStrategy.isAriaSelected() : !recentSectionsExists && i === 0, selected: renderStrategy.isSelected(), setsize: allNotebooks.length, posinset: i + 1 }) :
                    React.createElement(leafNode_1.LeafNode, { globals: _this.props.globals, node: renderStrategy, treeViewId: _this.treeViewId(), key: renderStrategy.getId(), id: renderStrategy.getId(), tabbable: !createNewNotebookExists && i === 0, focusOnMount: !createNewNotebookExists && !recentSectionsExists && focusOnMount && i === 0, ariaSelected: ariaSelectedId ? renderStrategy.isAriaSelected() : !recentSectionsExists && i === 0 });
            }
        });
        return recentSectionNodes.concat(createNewNotebook, allNotebookNodes);
    };
    OneNotePicker.prototype.onRecentSectionsClick = function (expanded) {
        this.setState({
            recentSectionsExpanded: expanded
        });
    };
    OneNotePicker.prototype.sortNotebooksByLastModifiedTime = function (notebook1, notebook2) {
        if (notebook1.lastModifiedTime && notebook2.lastModifiedTime) {
            if (notebook1.lastModifiedTime > notebook2.lastModifiedTime) {
                return -1;
            }
            else if (notebook2.lastModifiedTime > notebook1.lastModifiedTime) {
                return 1;
            }
        }
        return 0;
    };
    return OneNotePicker;
}(oneNotePickerBase_1.OneNotePickerBase));
exports.OneNotePicker = OneNotePicker;
//# sourceMappingURL=oneNotePicker.js.map