/// <reference types="react" />
import * as React from 'react';
import { OneNotePickerProps } from './oneNotePicker';
import { OneNoteSingleNotebookPickerProps } from './oneNoteSingleNotebookPicker';
import { GlobalProps } from './props/globalProps';
export interface OneNotePickerDropdownState {
    popupVisible: boolean;
}
export interface PickerProperties extends GlobalProps {
    dropdownLabel: string;
    popupDirection: 'bottom' | 'top';
    popupContentOverride?: JSX.Element;
}
export declare abstract class GenericOneNotePickerDropdown<T extends PickerProperties> extends React.Component<T, OneNotePickerDropdownState> {
    private wrapperRef;
    constructor(props: T);
    onClick(): void;
    onPickerItemClicked(): void;
    private setWrapperRef(node);
    private handleClickOutside(event);
    componentDidMount(): void;
    componentWillUnmount(): void;
    abstract getPickerElement(arg: T): JSX.Element;
    render(): JSX.Element;
}
export declare class OneNotePickerDropdown extends GenericOneNotePickerDropdown<OneNotePickerProps & PickerProperties> {
    getPickerElement(args: OneNotePickerProps): JSX.Element;
}
export declare class OneNoteSingleNotebookDropdown extends GenericOneNotePickerDropdown<OneNoteSingleNotebookPickerProps & PickerProperties> {
    getPickerElement(args: OneNoteSingleNotebookPickerProps): JSX.Element;
}
