"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var oneNotePicker_1 = require("./oneNotePicker");
var oneNoteSingleNotebookPicker_1 = require("./oneNoteSingleNotebookPicker");
var GenericOneNotePickerDropdown = /** @class */ (function (_super) {
    __extends(GenericOneNotePickerDropdown, _super);
    function GenericOneNotePickerDropdown(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            popupVisible: false
        };
        _this.handleClickOutside = _this.handleClickOutside.bind(_this);
        _this.setWrapperRef = _this.setWrapperRef.bind(_this);
        return _this;
    }
    GenericOneNotePickerDropdown.prototype.onClick = function () {
        this.setState({
            popupVisible: !this.state.popupVisible
        });
    };
    GenericOneNotePickerDropdown.prototype.onPickerItemClicked = function () {
        this.setState({
            popupVisible: false
        });
    };
    GenericOneNotePickerDropdown.prototype.setWrapperRef = function (node) {
        this.wrapperRef = node;
    };
    GenericOneNotePickerDropdown.prototype.handleClickOutside = function (event) {
        if (this.wrapperRef && !this.wrapperRef.contains(event.target) && this.state.popupVisible) {
            this.setState({
                popupVisible: false
            });
        }
    };
    GenericOneNotePickerDropdown.prototype.componentDidMount = function () {
        document.addEventListener('mousedown', this.handleClickOutside);
    };
    GenericOneNotePickerDropdown.prototype.componentWillUnmount = function () {
        document.removeEventListener('mousedown', this.handleClickOutside);
    };
    GenericOneNotePickerDropdown.prototype.render = function () {
        var _this = this;
        // TODO (machiam/jane) We should not modify props. We should copy to new object before passing it down.
        var newCallbacks = __assign({}, this.props.globals.callbacks);
        if (newCallbacks.onRecentSectionSelected) {
            var decorated_1 = newCallbacks.onRecentSectionSelected;
            newCallbacks.onRecentSectionSelected = function (section, breadcrumbs) {
                _this.onPickerItemClicked();
                decorated_1(section, breadcrumbs);
            };
        }
        if (newCallbacks.onSectionSelected) {
            var decorated_2 = newCallbacks.onSectionSelected;
            newCallbacks.onSectionSelected = function (section, breadcrumbs) {
                _this.onPickerItemClicked();
                decorated_2(section, breadcrumbs);
            };
        }
        if (newCallbacks.onPageSelected) {
            var decorated_3 = newCallbacks.onPageSelected;
            newCallbacks.onPageSelected = function (page, breadcrumbs) {
                _this.onPickerItemClicked();
                decorated_3(page, breadcrumbs);
            };
        }
        this.props.globals.callbacks = newCallbacks;
        return (React.createElement("div", { className: 'picker-dropdown', ref: this.setWrapperRef },
            React.createElement("div", { className: 'picker-dropdown-padding' },
                React.createElement("a", { className: 'picker-dropdown-toggle', onClick: this.onClick.bind(this) },
                    React.createElement("div", { className: 'dropdown-arrow-container' },
                        React.createElement("svg", { version: '1', id: 'Layer_1', xmlns: 'http://www.w3.org/2000/svg', viewBox: '0 0 16 16', focusable: "false" },
                            React.createElement("polygon", { id: 'XMLID_10_', points: '3.5,7 4.4,6.1 8,9.7 11.7,6.1 12.6,7 8,11.5' }))),
                    React.createElement("div", { className: 'picker-dropdown-toggle-label', title: this.props.dropdownLabel }, this.props.dropdownLabel))),
            this.state.popupVisible ?
                React.createElement("div", { className: 'picker-popup ' + (this.props.popupDirection === 'top' ? 'popup-upwards' : '') }, this.props.popupContentOverride ? this.props.popupContentOverride : this.getPickerElement(this.props)) :
                undefined));
    };
    return GenericOneNotePickerDropdown;
}(React.Component));
exports.GenericOneNotePickerDropdown = GenericOneNotePickerDropdown;
var OneNotePickerDropdown = /** @class */ (function (_super) {
    __extends(OneNotePickerDropdown, _super);
    function OneNotePickerDropdown() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OneNotePickerDropdown.prototype.getPickerElement = function (args) {
        return React.createElement(oneNotePicker_1.OneNotePicker, __assign({}, args));
    };
    return OneNotePickerDropdown;
}(GenericOneNotePickerDropdown));
exports.OneNotePickerDropdown = OneNotePickerDropdown;
var OneNoteSingleNotebookDropdown = /** @class */ (function (_super) {
    __extends(OneNoteSingleNotebookDropdown, _super);
    function OneNoteSingleNotebookDropdown() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OneNoteSingleNotebookDropdown.prototype.getPickerElement = function (args) {
        return React.createElement(oneNoteSingleNotebookPicker_1.OneNoteSingleNotebookPicker, __assign({}, args));
    };
    return OneNoteSingleNotebookDropdown;
}(GenericOneNotePickerDropdown));
exports.OneNoteSingleNotebookDropdown = OneNoteSingleNotebookDropdown;
//# sourceMappingURL=oneNotePickerDropdown.js.map