"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
require("./index.css?raw");
var oneNotePickerBase_1 = require("./oneNotePickerBase");
var sectionGroupRenderStrategy_1 = require("./components/sectionGroupRenderStrategy");
var sectionRenderStrategy_1 = require("./components/sectionRenderStrategy");
var expandableNode_1 = require("./components/treeView/expandableNode");
var leafNode_1 = require("./components/treeView/leafNode");
var OneNoteSingleNotebookPicker = /** @class */ (function (_super) {
    __extends(OneNoteSingleNotebookPicker, _super);
    function OneNoteSingleNotebookPicker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OneNoteSingleNotebookPicker.prototype.rootNodes = function () {
        var _this = this;
        var _a = this.props, sectionGroups = _a.sectionGroups, sections = _a.sections, globals = _a.globals;
        var focusOnMount = globals.focusOnMount, ariaSelectedId = globals.ariaSelectedId;
        var sectionGroupRenderStrategies = sectionGroups.map(function (sectionGroup) { return new sectionGroupRenderStrategy_1.SectionGroupRenderStrategy(sectionGroup, globals); });
        var sectionRenderStrategies = sections.map(function (section) { return new sectionRenderStrategy_1.SectionRenderStrategy(section, globals); });
        var noSectionGroups = sectionGroups.length === 0;
        var sectionGroupNodes = sectionGroupRenderStrategies.map(function (renderStrategy, i) {
            return React.createElement(expandableNode_1.ExpandableNode, { globals: _this.props.globals, expanded: renderStrategy.isExpanded(), node: renderStrategy, treeViewId: _this.treeViewId(), key: renderStrategy.getId(), id: renderStrategy.getId(), tabbable: i === 0, focusOnMount: focusOnMount && i === 0, ariaSelected: ariaSelectedId ? renderStrategy.isAriaSelected() : i === 0 });
        });
        var sectionNodes = sectionRenderStrategies.map(function (renderStrategy, i) {
            return !!_this.props.globals.callbacks.onPageSelected ?
                React.createElement(expandableNode_1.ExpandableNode, { globals: _this.props.globals, expanded: renderStrategy.isExpanded(), node: renderStrategy, treeViewId: _this.treeViewId(), key: renderStrategy.getId(), id: renderStrategy.getId(), tabbable: noSectionGroups && i === 0, focusOnMount: focusOnMount && noSectionGroups && i === 0, ariaSelected: ariaSelectedId ? renderStrategy.isAriaSelected() : noSectionGroups && i === 0 }) :
                React.createElement(leafNode_1.LeafNode, { globals: _this.props.globals, node: renderStrategy, treeViewId: _this.treeViewId(), key: renderStrategy.getId(), id: renderStrategy.getId(), tabbable: noSectionGroups && i === 0, focusOnMount: focusOnMount && noSectionGroups && i === 0, ariaSelected: ariaSelectedId ? renderStrategy.isAriaSelected() : noSectionGroups && i === 0 });
        });
        return sectionNodes.concat(sectionGroupNodes);
    };
    return OneNoteSingleNotebookPicker;
}(oneNotePickerBase_1.OneNotePickerBase));
exports.OneNoteSingleNotebookPicker = OneNoteSingleNotebookPicker;
//# sourceMappingURL=oneNoteSingleNotebookPicker.js.map