import * as OneNoteApi from 'onenoteapi';
import { OneNoteDataProvider } from './oneNoteDataProvider';
import { Notebook } from '../oneNoteDataStructures/notebook';
import { Section } from '../oneNoteDataStructures/section';
import { SectionGroup } from '../oneNoteDataStructures/sectionGroup';
import { SharedNotebookApiProperties } from '../oneNoteDataStructures/sharedNotebook';
import { Page } from '../oneNoteDataStructures/page';
import { SharedNotebook } from '../oneNoteDataStructures/sharedNotebook';
/**
 * Implements OneNoteDataProvider with external calls to OneNote's API.
 */
export declare class OneNoteApiDataProvider implements OneNoteDataProvider {
    private api;
    private responseTransformer;
    constructor(api: OneNoteApi.OneNoteApi);
    createNotebook(name: string): Promise<Notebook>;
    createSectionUnderNotebook(parent: Notebook, name: string): Promise<Section>;
    createSectionUnderSectionGroup(parent: SectionGroup, name: string): Promise<Section>;
    getNotebooks(expands?: number, excludeReadOnlyNotebooks?: boolean): Promise<Notebook[]>;
    getNotebookBySelfUrl(selfUrl: string, expands?: number): Promise<Notebook>;
    getPages(section: Section): Promise<Page[]>;
    getSpNotebooks(): Promise<SharedNotebook[]>;
    private isOdbNotebook(notebook);
    private getSharedNotebookName(sharedNotebook);
    private addQueryParamComponent(originalUrl, queryParamComponent);
    getSpNotebookProperties(spNotebook: SharedNotebook, expands?: number, excludeReadOnlyNotebooks?: boolean): Promise<SharedNotebookApiProperties>;
    private getNotebookSelfUrlFromSpUrl(spNotebookUrl);
    private getExpands(expands?);
}
